<%doc>

    A demonstration of <%defs> used within multiple contexts.
    The same <%def> is displayed inline and is also loaded
    directly by the controller in an AJAX request.
    
    This allows components to be used to build 
    a page within a single request, and also to be swapped out
    or redisplayed in response to asynchronous events.

</%doc>

<html>
<head>
    <script language="JavaScript" type="text/javascript" src="${h.url_for('/js/jquery-1.2.6.min.js')}"></script>
    <style>
        body {font-family:Tahoma, Geneva, Sans-serif;}
        .pagenum {float:right;}
        .page {width:600px;}
    </style>
</head>
<body>
    Select page:
    % for i in range(1, c.number_of_pages + 1):
        <a href="javascript:showPage(${i})">${i}</a> &nbsp; 
    % endfor
    
    <div id="display">
        ## render the "showpage()" def statically.
        ${showpage(c.page)}
    </div>
    
    <script>
        function showPage(pagenum) {
            ## call the page controller via HTTP.  Renders the
            ## "showpage()" def via AJAX.
            $("#display").load("${h.url_for(controller='page', action='read')}/" + pagenum);
        }
    </script>
</body>
</html>

<%def name="showpage(page)">
    <%doc>
        Given a model.Page object, render the page.
    </%doc>
    
    <div class="page">
        <div class="pagenum">Page: ${page.number}</div>
        <h3>${page.title}</h3>
        
        <pre>${page.content}</pre>
    </div>
    
</%def>
